<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <title>Getting Started with JavaScript</title>
</head>
<body>

    <h2>JavaScript Array Reference</h2>
    <!-- <button type="button" onclick="myFunction()">Try It</button> -->
    <p id="demo"></p>

    <script>
        //01............... constructor ..
        // var users = ["kamal", "Amit", "Kapil", "Veera"];
        // document.getElementById("demo").innerHTML = users.constructor
       
       //02............... length ..
        //  function myFunction(){
        //  var users = ["kamal", "Amit", "Kapil", "Veera"];
        //  document.getElementById("demo").innerHTML = users.length
        //  }
     
       //03...............UpperCase..
        //  Array.prototype.kamal = function() {
        //  var i;
        //  for (i = 0; i < this.length; i++){
        //  this[i] = this[i].toUpperCase();
        //   }
        // };
        // function myFunction(){
        // var users = ["kamal", "Amit", "Kapil", "Veera"];
        // users.kamal();
        // document.getElementById("demo").innerHTML = users;
        // }
        // myFunction()

        //04...............concat..
        // var user = ["kamal", "Amit", "Kapil", "Veera" + "<br>"];
        // var text = ["Text1", "Text2", "Text3", "Text4"];
        // document.getElementById("demo").innerHTML = user.concat(text);

        //05...............copyWithin..
        //  var Boys = ["kamal", "Amit", "Kapil", "Veera"];
        //  document.getElementById("demo").innerHTML = Boys;
        //  function myFunction(){
        //  document.getElementById("demo").innerHTML = Boys.copyWithin(3,1);
        //  }
        //  myFunction()

        //06...............fill..
        // var Boys = ["kamal", "Amit", "Kapil", "Veera"];
        // document.getElementById("demo").innerHTML= Boys;
        // function myFunction(){
        // document.getElementById("demo").innerHTML = Boys.fill("Jimiwal")
        // }
        // myFunction()

        //07...............filter..
        // var ages = [32, 33, 15, 16, 22, 25];
        // function kamal(age){
        //     return age > 18;
        // }
        // function myFunction(){
        // document.getElementById("demo").innerHTML = ages.filter(kamal)
        // }
        // myFunction()

        //08...............find..
        // var ages = [ 15, 16, 22, 25, 32, 33,];
        // function kamal(age){
        //     return age >= 18;
        // }
        // function myFunction(){
        // document.getElementById("demo").innerHTML = ages.find(kamal)
        // }


        //09...............findIndex..
        // var ages = [1, 2, 3, 5, 15, 33, 18, 55]
        // function kamal(age){
        //     return age >= 18;
        // }
        // function myFunction(){
        // document.getElementById("demo").innerHTML = ages.findIndex(kamal)
        // }


        //09...............forEach..
        // var users = ["kamal", "Kapil", "Chetan"]
        // users.forEach(myFunction);

        // function myFunction(text, index){
        // document.getElementById("demo").innerHTML +=  index  + ":" + text + "<br>";
        // }

        //10...............includes..
        // var users = ["kamal", "Amit", "Veera", "Yogi"];
        // var n = users.includes("kamal", 0);
        // document.getElementById("demo").innerHTML = n;

        //11...............indexOf..
        // var users = ["kamal", "Amit", "Veera", "Yogi"];
        // var n = users.indexOf("Veera");
        // document.getElementById("demo").innerHTML = n;

        //11...............keys..
        // var users = ["kamal", "Amit", "Veera", "Yogi"];
        // var x = users.keys()
        // for(n of x){
        // document.getElementById("demo").innerHTML += n + "<br>";
        // }

        // 12...............forEach..
        // var numbers = [5,4,8,7];
        // document.getElementById("demo").innerHTML = numbers + "<br>";
        // function myFunction(){
        // numbers.forEach(function(a,b,c,d) {
        // document.getElementById("demo").innerHTML += ("Item: " + a + " At Index: " + b + " In the Array: " + c + d + "<br>");
        // })
        // }
        // myFunction()

        //13...............forEach..
        // myCallBack(function (a, b, c, d){
        //     console.log('return from call back')
        //     console.log(a, b, c, d)
        // });

        // function myCallBack(next){
        //     console.log('myCallBack')
        //     next(5, 12, 3,4);
        // }

        //14...............reverse..
        // var users = ["kamal", "Amit", "Kapil", "Veera"];
        // document.getElementById("demo").innerHTML = users;

        // function myFunction() {
        // users.reverse();
        // document.getElementById("demo").innerHTML = users;
        // }

        //15...............shift..
        // var users = ["kamal", "Amit", "Kapil", "Veera"];
        // document.getElementById("demo").innerHTML = users;

        // function myFunction() {
        // users.shift();
        // document.getElementById("demo").innerHTML = users;
        // }
        
        //16...............slice..
        // function myFunction() {
        // var users = ["kamal", "Amit", "Kapil", "Veera"];
        // var citrus = users.slice(0,2);
        // document.getElementById("demo").innerHTML = citrus;
        // }

        //17...............short..
        // var users = ["Kamal", "Amit", "Kapil", "Veera"];
        // document.getElementById("demo").innerHTML = users;
        // function myFunction() {
        // users.sort();
        // document.getElementById("demo").innerHTML = users;
        // }

        //17...............splice..
        // var users = ["Kamal", "Amit", "Kapil", "Veera"];
        // document.getElementById("demo").innerHTML = users;
        // function myFunction() {
        // users.splice(2, 0, "Yogi", "Vinod");
        // document.getElementById("demo").innerHTML = users;
        // }

        //18...............valueOf..
       
    
    </script>
</body>
</html>